diff -crN linux-3.8.6-gentoo/arch/x86/include/asm/irq_vectors.h linux-3.8.6-gentoo-hyperv/arch/x86/include/asm/irq_vectors.h
*** linux-3.8.6-gentoo/arch/x86/include/asm/irq_vectors.h	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/arch/x86/include/asm/irq_vectors.h	Sat Apr 13 02:25:13 2013
***************
*** 109,116 ****
  
  #define UV_BAU_MESSAGE			0xf5
  
! /* Xen vector callback to receive events in a HVM domain */
! #define XEN_HVM_EVTCHN_CALLBACK		0xf3
  
  /*
   * Local APIC timer IRQ vector is on a different priority level,
--- 109,115 ----
  
  #define UV_BAU_MESSAGE			0xf5
  
! #define HYPERVISOR_CALLBACK_VECTOR	0xf3
  
  /*
   * Local APIC timer IRQ vector is on a different priority level,
diff -crN linux-3.8.6-gentoo/arch/x86/include/asm/mshyperv.h linux-3.8.6-gentoo-hyperv/arch/x86/include/asm/mshyperv.h
*** linux-3.8.6-gentoo/arch/x86/include/asm/mshyperv.h	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/arch/x86/include/asm/mshyperv.h	Sat Apr 13 02:25:14 2013
***************
*** 3,8 ****
--- 3,9 ----
  
  #include <linux/types.h>
  #include <asm/hyperv.h>
+ #include <linux/interrupt.h>
  
  struct ms_hyperv_info {
  	u32 features;
***************
*** 11,14 ****
--- 12,19 ----
  
  extern struct ms_hyperv_info ms_hyperv;
  
+ void hyperv_callback_vector(void);
+ void hyperv_vector_handler(struct pt_regs *regs);
+ void hv_register_vmbus_handler(int irq, irq_handler_t handler);
+ 
  #endif
diff -crN linux-3.8.6-gentoo/arch/x86/kernel/cpu/mshyperv.c linux-3.8.6-gentoo-hyperv/arch/x86/kernel/cpu/mshyperv.c
*** linux-3.8.6-gentoo/arch/x86/kernel/cpu/mshyperv.c	Sat Apr 13 02:03:28 2013
--- linux-3.8.6-gentoo-hyperv/arch/x86/kernel/cpu/mshyperv.c	Sat Apr 13 02:24:52 2013
***************
*** 14,23 ****
--- 14,28 ----
  #include <linux/time.h>
  #include <linux/clocksource.h>
  #include <linux/module.h>
+ #include <linux/hardirq.h>
+ #include <linux/interrupt.h>
  #include <asm/processor.h>
  #include <asm/hypervisor.h>
  #include <asm/hyperv.h>
  #include <asm/mshyperv.h>
+ #include <asm/desc.h>
+ #include <asm/idle.h>
+ #include <asm/irq_regs.h>
  
  struct ms_hyperv_info ms_hyperv;
  EXPORT_SYMBOL_GPL(ms_hyperv);
***************
*** 30,35 ****
--- 35,47 ----
  	if (!boot_cpu_has(X86_FEATURE_HYPERVISOR))
  		return false;
  
+ 	/*
+ 	 * Xen emulates Hyper-V to support enlightened Windows.
+ 	 * Check to see first if we are on a Xen Hypervisor.
+ 	 */
+ 	if (xen_cpuid_base())
+ 		return false;
+ 
  	cpuid(HYPERV_CPUID_VENDOR_AND_MAX_FUNCTIONS,
  	      &eax, &hyp_signature[0], &hyp_signature[1], &hyp_signature[2]);
  
***************
*** 70,75 ****
--- 82,93 ----
  
  	if (ms_hyperv.features & HV_X64_MSR_TIME_REF_COUNT_AVAILABLE)
  		clocksource_register_hz(&hyperv_cs, NSEC_PER_SEC/100);
+ #if defined(CONFIG_HYPERV) || defined(CONFIG_HYPERV_MODULE)
+ 	/*
+ 	 * Setup the IDT for hypervisor callback.
+ 	 */
+ 	alloc_intr_gate(HYPERVISOR_CALLBACK_VECTOR, hyperv_callback_vector);
+ #endif
  }
  
  const __refconst struct hypervisor_x86 x86_hyper_ms_hyperv = {
***************
*** 78,80 ****
--- 96,131 ----
  	.init_platform		= ms_hyperv_init_platform,
  };
  EXPORT_SYMBOL(x86_hyper_ms_hyperv);
+ 
+ #if defined(CONFIG_HYPERV) || defined(CONFIG_HYPERV_MODULE)
+ static int vmbus_irq = -1;
+ static irq_handler_t vmbus_isr;
+ 
+ void hv_register_vmbus_handler(int irq, irq_handler_t handler)
+ {
+ 	vmbus_irq = irq;
+ 	vmbus_isr = handler;
+ }
+ 
+ void hyperv_vector_handler(struct pt_regs *regs)
+ {
+ 	struct pt_regs *old_regs = set_irq_regs(regs);
+ 	struct irq_desc *desc;
+ 
+ 	irq_enter();
+ 	exit_idle();
+ 
+ 	desc = irq_to_desc(vmbus_irq);
+ 
+ 	if (desc)
+ 		generic_handle_irq_desc(vmbus_irq, desc);
+ 
+ 	irq_exit();
+ 	set_irq_regs(old_regs);
+ }
+ #else
+ void hv_register_vmbus_handler(int irq, irq_handler_t handler)
+ {
+ }
+ #endif
+ EXPORT_SYMBOL_GPL(hv_register_vmbus_handler);
diff -crN linux-3.8.6-gentoo/arch/x86/kernel/entry_32.S linux-3.8.6-gentoo-hyperv/arch/x86/kernel/entry_32.S
*** linux-3.8.6-gentoo/arch/x86/kernel/entry_32.S	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/arch/x86/kernel/entry_32.S	Sat Apr 13 02:12:27 2013
***************
*** 1091,1101 ****
  	_ASM_EXTABLE(4b,9b)
  ENDPROC(xen_failsafe_callback)
  
! BUILD_INTERRUPT3(xen_hvm_callback_vector, XEN_HVM_EVTCHN_CALLBACK,
  		xen_evtchn_do_upcall)
  
  #endif	/* CONFIG_XEN */
  
  #ifdef CONFIG_FUNCTION_TRACER
  #ifdef CONFIG_DYNAMIC_FTRACE
  
--- 1091,1108 ----
  	_ASM_EXTABLE(4b,9b)
  ENDPROC(xen_failsafe_callback)
  
! BUILD_INTERRUPT3(xen_hvm_callback_vector, HYPERVISOR_CALLBACK_VECTOR,
  		xen_evtchn_do_upcall)
  
  #endif	/* CONFIG_XEN */
  
+ #if IS_ENABLED(CONFIG_HYPERV)
+ 
+ BUILD_INTERRUPT3(hyperv_callback_vector, HYPERVISOR_CALLBACK_VECTOR,
+ 		hyperv_vector_handler)
+ 
+ #endif /* CONFIG_HYPERV */
+ 
  #ifdef CONFIG_FUNCTION_TRACER
  #ifdef CONFIG_DYNAMIC_FTRACE
  
diff -crN linux-3.8.6-gentoo/arch/x86/kernel/entry_64.S linux-3.8.6-gentoo-hyperv/arch/x86/kernel/entry_64.S
*** linux-3.8.6-gentoo/arch/x86/kernel/entry_64.S	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/arch/x86/kernel/entry_64.S	Sat Apr 13 02:12:27 2013
***************
*** 1454,1464 ****
  	CFI_ENDPROC
  END(xen_failsafe_callback)
  
! apicinterrupt XEN_HVM_EVTCHN_CALLBACK \
  	xen_hvm_callback_vector xen_evtchn_do_upcall
  
  #endif /* CONFIG_XEN */
  
  /*
   * Some functions should be protected against kprobes
   */
--- 1454,1471 ----
  	CFI_ENDPROC
  END(xen_failsafe_callback)
  
! apicinterrupt HYPERVISOR_CALLBACK_VECTOR \
  	xen_hvm_callback_vector xen_evtchn_do_upcall
  
  #endif /* CONFIG_XEN */
  
+ #if IS_ENABLED(CONFIG_HYPERV)
+ 
+ apicinterrupt HYPERVISOR_CALLBACK_VECTOR \
+ 	hyperv_callback_vector hyperv_vector_handler
+ 
+ #endif /* CONFIG_HYPERV */
+ 
  /*
   * Some functions should be protected against kprobes
   */
diff -crN linux-3.8.6-gentoo/drivers/hid/hid-hyperv.c linux-3.8.6-gentoo-hyperv/drivers/hid/hid-hyperv.c
*** linux-3.8.6-gentoo/drivers/hid/hid-hyperv.c	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hid/hid-hyperv.c	Sat Apr 13 02:24:31 2013
***************
*** 568,575 ****
  
  static const struct hv_vmbus_device_id id_table[] = {
  	/* Mouse guid */
! 	{ VMBUS_DEVICE(0x9E, 0xB6, 0xA8, 0xCF, 0x4A, 0x5B, 0xc0, 0x4c,
! 		       0xB9, 0x8B, 0x8B, 0xA1, 0xA1, 0xF3, 0xF9, 0x5A) },
  	{ },
  };
  
--- 568,574 ----
  
  static const struct hv_vmbus_device_id id_table[] = {
  	/* Mouse guid */
! 	{ HV_MOUSE_GUID, },
  	{ },
  };
  
***************
*** 594,598 ****
--- 593,599 ----
  
  MODULE_LICENSE("GPL");
  MODULE_VERSION(HV_DRV_VERSION);
+ /* bind to old driver to simplify upgrade path */
+ MODULE_ALIAS("hv_mouse");
  module_init(mousevsc_init);
  module_exit(mousevsc_exit);
diff -crN linux-3.8.6-gentoo/drivers/hv/Kconfig linux-3.8.6-gentoo-hyperv/drivers/hv/Kconfig
*** linux-3.8.6-gentoo/drivers/hv/Kconfig	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/Kconfig	Sat Apr 13 02:25:44 2013
***************
*** 2,8 ****
  
  config HYPERV
  	tristate "Microsoft Hyper-V client drivers"
! 	depends on X86 && ACPI && PCI
  	help
  	  Select this option to run Linux as a Hyper-V client operating
  	  system.
--- 2,8 ----
  
  config HYPERV
  	tristate "Microsoft Hyper-V client drivers"
! 	depends on X86 && ACPI && PCI && X86_LOCAL_APIC && !XEN
  	help
  	  Select this option to run Linux as a Hyper-V client operating
  	  system.
***************
*** 15,21 ****
  
  config HYPERV_BALLOON
  	tristate "Microsoft Hyper-V Balloon driver"
! 	depends on HYPERV
  	help
  	  Select this option to enable Hyper-V Balloon driver.
  
--- 15,21 ----
  
  config HYPERV_BALLOON
  	tristate "Microsoft Hyper-V Balloon driver"
! 	depends on HYPERV = y
  	help
  	  Select this option to enable Hyper-V Balloon driver.
  
diff -crN linux-3.8.6-gentoo/drivers/hv/Makefile linux-3.8.6-gentoo-hyperv/drivers/hv/Makefile
*** linux-3.8.6-gentoo/drivers/hv/Makefile	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/Makefile	Sat Apr 13 02:25:32 2013
***************
*** 5,8 ****
  hv_vmbus-y := vmbus_drv.o \
  		 hv.o connection.o channel.o \
  		 channel_mgmt.o ring_buffer.o
! hv_utils-y := hv_util.o hv_kvp.o
--- 5,8 ----
  hv_vmbus-y := vmbus_drv.o \
  		 hv.o connection.o channel.o \
  		 channel_mgmt.o ring_buffer.o
! hv_utils-y := hv_util.o hv_kvp.o hv_snapshot.o
diff -crN linux-3.8.6-gentoo/drivers/hv/channel.c linux-3.8.6-gentoo-hyperv/drivers/hv/channel.c
*** linux-3.8.6-gentoo/drivers/hv/channel.c	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/channel.c	Sat Apr 13 02:24:31 2013
***************
*** 55,61 ****
  					[channel->monitor_grp].pending);
  
  	} else {
! 		vmbus_set_event(channel->offermsg.child_relid);
  	}
  }
  
--- 55,61 ----
  					[channel->monitor_grp].pending);
  
  	} else {
! 		vmbus_set_event(channel);
  	}
  }
  
***************
*** 181,187 ****
  	open_msg->ringbuffer_gpadlhandle = newchannel->ringbuffer_gpadlhandle;
  	open_msg->downstream_ringbuffer_pageoffset = send_ringbuffer_size >>
  						  PAGE_SHIFT;
! 	open_msg->server_contextarea_gpadlhandle = 0;
  
  	if (userdatalen > MAX_USER_DEFINED_BYTES) {
  		err = -EINVAL;
--- 181,187 ----
  	open_msg->ringbuffer_gpadlhandle = newchannel->ringbuffer_gpadlhandle;
  	open_msg->downstream_ringbuffer_pageoffset = send_ringbuffer_size >>
  						  PAGE_SHIFT;
! 	open_msg->target_vp = newchannel->target_vp;
  
  	if (userdatalen > MAX_USER_DEFINED_BYTES) {
  		err = -EINVAL;
***************
*** 564,569 ****
--- 564,570 ----
  	struct scatterlist bufferlist[3];
  	u64 aligned_data = 0;
  	int ret;
+ 	bool signal = false;
  
  
  	/* Setup the descriptor */
***************
*** 580,588 ****
  	sg_set_buf(&bufferlist[2], &aligned_data,
  		   packetlen_aligned - packetlen);
  
! 	ret = hv_ringbuffer_write(&channel->outbound, bufferlist, 3);
  
! 	if (ret == 0 && !hv_get_ringbuffer_interrupt_mask(&channel->outbound))
  		vmbus_setevent(channel);
  
  	return ret;
--- 581,589 ----
  	sg_set_buf(&bufferlist[2], &aligned_data,
  		   packetlen_aligned - packetlen);
  
! 	ret = hv_ringbuffer_write(&channel->outbound, bufferlist, 3, &signal);
  
! 	if (ret == 0 && signal)
  		vmbus_setevent(channel);
  
  	return ret;
***************
*** 606,611 ****
--- 607,613 ----
  	u32 packetlen_aligned;
  	struct scatterlist bufferlist[3];
  	u64 aligned_data = 0;
+ 	bool signal = false;
  
  	if (pagecount > MAX_PAGE_BUFFER_COUNT)
  		return -EINVAL;
***************
*** 641,649 ****
  	sg_set_buf(&bufferlist[2], &aligned_data,
  		packetlen_aligned - packetlen);
  
! 	ret = hv_ringbuffer_write(&channel->outbound, bufferlist, 3);
  
! 	if (ret == 0 && !hv_get_ringbuffer_interrupt_mask(&channel->outbound))
  		vmbus_setevent(channel);
  
  	return ret;
--- 643,651 ----
  	sg_set_buf(&bufferlist[2], &aligned_data,
  		packetlen_aligned - packetlen);
  
! 	ret = hv_ringbuffer_write(&channel->outbound, bufferlist, 3, &signal);
  
! 	if (ret == 0 && signal)
  		vmbus_setevent(channel);
  
  	return ret;
***************
*** 665,670 ****
--- 667,673 ----
  	u32 packetlen_aligned;
  	struct scatterlist bufferlist[3];
  	u64 aligned_data = 0;
+ 	bool signal = false;
  	u32 pfncount = NUM_PAGES_SPANNED(multi_pagebuffer->offset,
  					 multi_pagebuffer->len);
  
***************
*** 703,711 ****
  	sg_set_buf(&bufferlist[2], &aligned_data,
  		packetlen_aligned - packetlen);
  
! 	ret = hv_ringbuffer_write(&channel->outbound, bufferlist, 3);
  
! 	if (ret == 0 && !hv_get_ringbuffer_interrupt_mask(&channel->outbound))
  		vmbus_setevent(channel);
  
  	return ret;
--- 706,714 ----
  	sg_set_buf(&bufferlist[2], &aligned_data,
  		packetlen_aligned - packetlen);
  
! 	ret = hv_ringbuffer_write(&channel->outbound, bufferlist, 3, &signal);
  
! 	if (ret == 0 && signal)
  		vmbus_setevent(channel);
  
  	return ret;
***************
*** 732,737 ****
--- 735,741 ----
  	u32 packetlen;
  	u32 userlen;
  	int ret;
+ 	bool signal = false;
  
  	*buffer_actual_len = 0;
  	*requestid = 0;
***************
*** 758,765 ****
  
  	/* Copy over the packet to the user buffer */
  	ret = hv_ringbuffer_read(&channel->inbound, buffer, userlen,
! 			     (desc.offset8 << 3));
  
  
  	return 0;
  }
--- 762,771 ----
  
  	/* Copy over the packet to the user buffer */
  	ret = hv_ringbuffer_read(&channel->inbound, buffer, userlen,
! 			     (desc.offset8 << 3), &signal);
  
+ 	if (signal)
+ 		vmbus_setevent(channel);
  
  	return 0;
  }
***************
*** 774,781 ****
  {
  	struct vmpacket_descriptor desc;
  	u32 packetlen;
- 	u32 userlen;
  	int ret;
  
  	*buffer_actual_len = 0;
  	*requestid = 0;
--- 780,787 ----
  {
  	struct vmpacket_descriptor desc;
  	u32 packetlen;
  	int ret;
+ 	bool signal = false;
  
  	*buffer_actual_len = 0;
  	*requestid = 0;
***************
*** 788,794 ****
  
  
  	packetlen = desc.len8 << 3;
- 	userlen = packetlen - (desc.offset8 << 3);
  
  	*buffer_actual_len = packetlen;
  
--- 794,799 ----
***************
*** 802,808 ****
  	*requestid = desc.trans_id;
  
  	/* Copy over the entire packet to the user buffer */
! 	ret = hv_ringbuffer_read(&channel->inbound, buffer, packetlen, 0);
  
  	return 0;
  }
--- 807,817 ----
  	*requestid = desc.trans_id;
  
  	/* Copy over the entire packet to the user buffer */
! 	ret = hv_ringbuffer_read(&channel->inbound, buffer, packetlen, 0,
! 				 &signal);
! 
! 	if (signal)
! 		vmbus_setevent(channel);
  
  	return 0;
  }
diff -crN linux-3.8.6-gentoo/drivers/hv/channel_mgmt.c linux-3.8.6-gentoo-hyperv/drivers/hv/channel_mgmt.c
*** linux-3.8.6-gentoo/drivers/hv/channel_mgmt.c	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/channel_mgmt.c	Sat Apr 13 02:24:31 2013
***************
*** 165,172 ****
--- 165,183 ----
  	struct vmbus_channel *channel = container_of(work,
  						     struct vmbus_channel,
  						     work);
+ 	unsigned long flags;
+ 	struct vmbus_channel_relid_released msg;
  
  	vmbus_device_unregister(channel->device_obj);
+ 	memset(&msg, 0, sizeof(struct vmbus_channel_relid_released));
+ 	msg.child_relid = channel->offermsg.child_relid;
+ 	msg.header.msgtype = CHANNELMSG_RELID_RELEASED;
+ 	vmbus_post_msg(&msg, sizeof(struct vmbus_channel_relid_released));
+ 
+ 	spin_lock_irqsave(&vmbus_connection.channel_lock, flags);
+ 	list_del(&channel->listentry);
+ 	spin_unlock_irqrestore(&vmbus_connection.channel_lock, flags);
+ 	free_channel(channel);
  }
  
  void vmbus_free_channels(void)
***************
*** 257,262 ****
--- 268,337 ----
  	}
  }
  
+ enum {
+ 	IDE = 0,
+ 	SCSI,
+ 	NIC,
+ 	MAX_PERF_CHN,
+ };
+ 
+ /*
+  * This is an array of device_ids (device types) that are performance critical.
+  * We attempt to distribute the interrupt load for these devices across
+  * all available CPUs.
+  */
+ static const struct hv_vmbus_device_id hp_devs[] = {
+ 	/* IDE */
+ 	{ HV_IDE_GUID, },
+ 	/* Storage - SCSI */
+ 	{ HV_SCSI_GUID, },
+ 	/* Network */
+ 	{ HV_NIC_GUID, },
+ };
+ 
+ 
+ /*
+  * We use this state to statically distribute the channel interrupt load.
+  */
+ static u32  next_vp;
+ 
+ /*
+  * Starting with Win8, we can statically distribute the incoming
+  * channel interrupt load by binding a channel to VCPU. We
+  * implement here a simple round robin scheme for distributing
+  * the interrupt load.
+  * We will bind channels that are not performance critical to cpu 0 and
+  * performance critical channels (IDE, SCSI and Network) will be uniformly
+  * distributed across all available CPUs.
+  */
+ static u32 get_vp_index(uuid_le *type_guid)
+ {
+ 	u32 cur_cpu;
+ 	int i;
+ 	bool perf_chn = false;
+ 	u32 max_cpus = num_online_cpus();
+ 
+ 	for (i = IDE; i < MAX_PERF_CHN; i++) {
+ 		if (!memcmp(type_guid->b, hp_devs[i].guid,
+ 				 sizeof(uuid_le))) {
+ 			perf_chn = true;
+ 			break;
+ 		}
+ 	}
+ 	if ((vmbus_proto_version == VERSION_WS2008) ||
+ 	    (vmbus_proto_version == VERSION_WIN7) || (!perf_chn)) {
+ 		/*
+ 		 * Prior to win8, all channel interrupts are
+ 		 * delivered on cpu 0.
+ 		 * Also if the channel is not a performance critical
+ 		 * channel, bind it to cpu 0.
+ 		 */
+ 		return 0;
+ 	}
+ 	cur_cpu = (++next_vp % max_cpus);
+ 	return cur_cpu;
+ }
+ 
  /*
   * vmbus_onoffer - Handler for channel offers from vmbus in parent partition.
   *
***************
*** 275,280 ****
--- 350,384 ----
  		return;
  	}
  
+ 	/*
+ 	 * By default we setup state to enable batched
+ 	 * reading. A specific service can choose to
+ 	 * disable this prior to opening the channel.
+ 	 */
+ 	newchannel->batched_reading = true;
+ 
+ 	/*
+ 	 * Setup state for signalling the host.
+ 	 */
+ 	newchannel->sig_event = (struct hv_input_signal_event *)
+ 				(ALIGN((unsigned long)
+ 				&newchannel->sig_buf,
+ 				HV_HYPERCALL_PARAM_ALIGN));
+ 
+ 	newchannel->sig_event->connectionid.asu32 = 0;
+ 	newchannel->sig_event->connectionid.u.id = VMBUS_EVENT_CONNECTION_ID;
+ 	newchannel->sig_event->flag_number = 0;
+ 	newchannel->sig_event->rsvdz = 0;
+ 
+ 	if (vmbus_proto_version != VERSION_WS2008) {
+ 		newchannel->is_dedicated_interrupt =
+ 				(offer->is_dedicated_interrupt != 0);
+ 		newchannel->sig_event->connectionid.u.id =
+ 				offer->connection_id;
+ 	}
+ 
+ 	newchannel->target_vp = get_vp_index(&offer->offer.if_type);
+ 
  	memcpy(&newchannel->offermsg, offer,
  	       sizeof(struct vmbus_channel_offer_channel));
  	newchannel->monitor_grp = (u8)offer->monitorid / 32;
diff -crN linux-3.8.6-gentoo/drivers/hv/connection.c linux-3.8.6-gentoo-hyperv/drivers/hv/connection.c
*** linux-3.8.6-gentoo/drivers/hv/connection.c	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/connection.c	Sat Apr 13 02:24:31 2013
***************
*** 30,35 ****
--- 30,36 ----
  #include <linux/slab.h>
  #include <linux/vmalloc.h>
  #include <linux/hyperv.h>
+ #include <linux/module.h>
  #include <asm/hyperv.h>
  #include "hyperv_vmbus.h"
  
***************
*** 40,54 ****
  };
  
  /*
   * vmbus_connect - Sends a connect request on the partition service connection
   */
  int vmbus_connect(void)
  {
  	int ret = 0;
- 	int t;
  	struct vmbus_channel_msginfo *msginfo = NULL;
! 	struct vmbus_channel_initiate_contact *msg;
! 	unsigned long flags;
  
  	/* Initialize the vmbus connection */
  	vmbus_connection.conn_state = CONNECTING;
--- 41,139 ----
  };
  
  /*
+  * Negotiated protocol version with the host.
+  */
+ __u32 vmbus_proto_version;
+ EXPORT_SYMBOL_GPL(vmbus_proto_version);
+ 
+ static __u32 vmbus_get_next_version(__u32 current_version)
+ {
+ 	switch (current_version) {
+ 	case (VERSION_WIN7):
+ 		return VERSION_WS2008;
+ 
+ 	case (VERSION_WIN8):
+ 		return VERSION_WIN7;
+ 
+ 	case (VERSION_WS2008):
+ 	default:
+ 		return VERSION_INVAL;
+ 	}
+ }
+ 
+ static int vmbus_negotiate_version(struct vmbus_channel_msginfo *msginfo,
+ 					__u32 version)
+ {
+ 	int ret = 0;
+ 	struct vmbus_channel_initiate_contact *msg;
+ 	unsigned long flags;
+ 	int t;
+ 
+ 	init_completion(&msginfo->waitevent);
+ 
+ 	msg = (struct vmbus_channel_initiate_contact *)msginfo->msg;
+ 
+ 	msg->header.msgtype = CHANNELMSG_INITIATE_CONTACT;
+ 	msg->vmbus_version_requested = version;
+ 	msg->interrupt_page = virt_to_phys(vmbus_connection.int_page);
+ 	msg->monitor_page1 = virt_to_phys(vmbus_connection.monitor_pages);
+ 	msg->monitor_page2 = virt_to_phys(
+ 			(void *)((unsigned long)vmbus_connection.monitor_pages +
+ 				 PAGE_SIZE));
+ 
+ 	/*
+ 	 * Add to list before we send the request since we may
+ 	 * receive the response before returning from this routine
+ 	 */
+ 	spin_lock_irqsave(&vmbus_connection.channelmsg_lock, flags);
+ 	list_add_tail(&msginfo->msglistentry,
+ 		      &vmbus_connection.chn_msg_list);
+ 
+ 	spin_unlock_irqrestore(&vmbus_connection.channelmsg_lock, flags);
+ 
+ 	ret = vmbus_post_msg(msg,
+ 			       sizeof(struct vmbus_channel_initiate_contact));
+ 	if (ret != 0) {
+ 		spin_lock_irqsave(&vmbus_connection.channelmsg_lock, flags);
+ 		list_del(&msginfo->msglistentry);
+ 		spin_unlock_irqrestore(&vmbus_connection.channelmsg_lock,
+ 					flags);
+ 		return ret;
+ 	}
+ 
+ 	/* Wait for the connection response */
+ 	t =  wait_for_completion_timeout(&msginfo->waitevent, 5*HZ);
+ 	if (t == 0) {
+ 		spin_lock_irqsave(&vmbus_connection.channelmsg_lock,
+ 				flags);
+ 		list_del(&msginfo->msglistentry);
+ 		spin_unlock_irqrestore(&vmbus_connection.channelmsg_lock,
+ 					flags);
+ 		return -ETIMEDOUT;
+ 	}
+ 
+ 	spin_lock_irqsave(&vmbus_connection.channelmsg_lock, flags);
+ 	list_del(&msginfo->msglistentry);
+ 	spin_unlock_irqrestore(&vmbus_connection.channelmsg_lock, flags);
+ 
+ 	/* Check if successful */
+ 	if (msginfo->response.version_response.version_supported) {
+ 		vmbus_connection.conn_state = CONNECTED;
+ 	} else {
+ 		return -ECONNREFUSED;
+ 	}
+ 
+ 	return ret;
+ }
+ 
+ /*
   * vmbus_connect - Sends a connect request on the partition service connection
   */
  int vmbus_connect(void)
  {
  	int ret = 0;
  	struct vmbus_channel_msginfo *msginfo = NULL;
! 	__u32 version;
  
  	/* Initialize the vmbus connection */
  	vmbus_connection.conn_state = CONNECTING;
***************
*** 99,167 ****
  		goto cleanup;
  	}
  
- 	init_completion(&msginfo->waitevent);
- 
- 	msg = (struct vmbus_channel_initiate_contact *)msginfo->msg;
- 
- 	msg->header.msgtype = CHANNELMSG_INITIATE_CONTACT;
- 	msg->vmbus_version_requested = VMBUS_REVISION_NUMBER;
- 	msg->interrupt_page = virt_to_phys(vmbus_connection.int_page);
- 	msg->monitor_page1 = virt_to_phys(vmbus_connection.monitor_pages);
- 	msg->monitor_page2 = virt_to_phys(
- 			(void *)((unsigned long)vmbus_connection.monitor_pages +
- 				 PAGE_SIZE));
- 
  	/*
! 	 * Add to list before we send the request since we may
! 	 * receive the response before returning from this routine
  	 */
- 	spin_lock_irqsave(&vmbus_connection.channelmsg_lock, flags);
- 	list_add_tail(&msginfo->msglistentry,
- 		      &vmbus_connection.chn_msg_list);
  
! 	spin_unlock_irqrestore(&vmbus_connection.channelmsg_lock, flags);
! 
! 	ret = vmbus_post_msg(msg,
! 			       sizeof(struct vmbus_channel_initiate_contact));
! 	if (ret != 0) {
! 		spin_lock_irqsave(&vmbus_connection.channelmsg_lock, flags);
! 		list_del(&msginfo->msglistentry);
! 		spin_unlock_irqrestore(&vmbus_connection.channelmsg_lock,
! 					flags);
! 		goto cleanup;
! 	}
  
! 	/* Wait for the connection response */
! 	t =  wait_for_completion_timeout(&msginfo->waitevent, 5*HZ);
! 	if (t == 0) {
! 		spin_lock_irqsave(&vmbus_connection.channelmsg_lock,
! 				flags);
! 		list_del(&msginfo->msglistentry);
! 		spin_unlock_irqrestore(&vmbus_connection.channelmsg_lock,
! 					flags);
! 		ret = -ETIMEDOUT;
! 		goto cleanup;
! 	}
  
! 	spin_lock_irqsave(&vmbus_connection.channelmsg_lock, flags);
! 	list_del(&msginfo->msglistentry);
! 	spin_unlock_irqrestore(&vmbus_connection.channelmsg_lock, flags);
  
! 	/* Check if successful */
! 	if (msginfo->response.version_response.version_supported) {
! 		vmbus_connection.conn_state = CONNECTED;
! 	} else {
! 		pr_err("Unable to connect, "
! 			"Version %d not supported by Hyper-V\n",
! 			VMBUS_REVISION_NUMBER);
! 		ret = -ECONNREFUSED;
  		goto cleanup;
! 	}
  
  	kfree(msginfo);
  	return 0;
  
  cleanup:
  	vmbus_connection.conn_state = DISCONNECTED;
  
  	if (vmbus_connection.work_queue)
--- 184,221 ----
  		goto cleanup;
  	}
  
  	/*
! 	 * Negotiate a compatible VMBUS version number with the
! 	 * host. We start with the highest number we can support
! 	 * and work our way down until we negotiate a compatible
! 	 * version.
  	 */
  
! 	version = VERSION_CURRENT;
  
! 	do {
! 		ret = vmbus_negotiate_version(msginfo, version);
! 		if (ret == 0)
! 			break;
  
! 		version = vmbus_get_next_version(version);
! 	} while (version != VERSION_INVAL);
  
! 	if (version == VERSION_INVAL)
  		goto cleanup;
! 
! 	vmbus_proto_version = version;
! 	pr_info("Hyper-V Host Build:%d-%d.%d-%d-%d.%d; Vmbus version:%d.%d\n",
! 		    host_info_eax, host_info_ebx >> 16,
! 		    host_info_ebx & 0xFFFF, host_info_ecx,
! 		    host_info_edx >> 24, host_info_edx & 0xFFFFFF,
! 		    version >> 16, version & 0xFFFF);
  
  	kfree(msginfo);
  	return 0;
  
  cleanup:
+ 	pr_err("Unable to connect to host\n");
  	vmbus_connection.conn_state = DISCONNECTED;
  
  	if (vmbus_connection.work_queue)
***************
*** 212,217 ****
--- 266,274 ----
  {
  	struct vmbus_channel *channel;
  	unsigned long flags;
+ 	void *arg;
+ 	bool read_state;
+ 	u32 bytes_to_read;
  
  	/*
  	 * Find the channel based on this relid and invokes the
***************
*** 234,243 ****
  	 */
  
  	spin_lock_irqsave(&channel->inbound_lock, flags);
! 	if (channel->onchannel_callback != NULL)
! 		channel->onchannel_callback(channel->channel_callback_context);
! 	else
  		pr_err("no channel callback for relid - %u\n", relid);
  
  	spin_unlock_irqrestore(&channel->inbound_lock, flags);
  }
--- 291,319 ----
  	 */
  
  	spin_lock_irqsave(&channel->inbound_lock, flags);
! 	if (channel->onchannel_callback != NULL) {
! 		arg = channel->channel_callback_context;
! 		read_state = channel->batched_reading;
! 		/*
! 		 * This callback reads the messages sent by the host.
! 		 * We can optimize host to guest signaling by ensuring:
! 		 * 1. While reading the channel, we disable interrupts from
! 		 *    host.
! 		 * 2. Ensure that we process all posted messages from the host
! 		 *    before returning from this callback.
! 		 * 3. Once we return, enable signaling from the host. Once this
! 		 *    state is set we check to see if additional packets are
! 		 *    available to read. In this case we repeat the process.
! 		 */
! 
! 		do {
! 			hv_begin_read(&channel->inbound);
! 			channel->onchannel_callback(arg);
! 			bytes_to_read = hv_end_read(&channel->inbound);
! 		} while (read_state && (bytes_to_read != 0));
! 	} else {
  		pr_err("no channel callback for relid - %u\n", relid);
+ 	}
  
  	spin_unlock_irqrestore(&channel->inbound_lock, flags);
  }
***************
*** 248,257 ****
  void vmbus_on_event(unsigned long data)
  {
  	u32 dword;
! 	u32 maxdword = MAX_NUM_CHANNELS_SUPPORTED >> 5;
  	int bit;
  	u32 relid;
! 	u32 *recv_int_page = vmbus_connection.recv_int_page;
  
  	/* Check events */
  	if (!recv_int_page)
--- 324,355 ----
  void vmbus_on_event(unsigned long data)
  {
  	u32 dword;
! 	u32 maxdword;
  	int bit;
  	u32 relid;
! 	u32 *recv_int_page = NULL;
! 	void *page_addr;
! 	int cpu = smp_processor_id();
! 	union hv_synic_event_flags *event;
! 
! 	if ((vmbus_proto_version == VERSION_WS2008) ||
! 		(vmbus_proto_version == VERSION_WIN7)) {
! 		maxdword = MAX_NUM_CHANNELS_SUPPORTED >> 5;
! 		recv_int_page = vmbus_connection.recv_int_page;
! 	} else {
! 		/*
! 		 * When the host is win8 and beyond, the event page
! 		 * can be directly checked to get the id of the channel
! 		 * that has the interrupt pending.
! 		 */
! 		maxdword = HV_EVENT_FLAGS_DWORD_COUNT;
! 		page_addr = hv_context.synic_event_page[cpu];
! 		event = (union hv_synic_event_flags *)page_addr +
! 						 VMBUS_MESSAGE_SINT;
! 		recv_int_page = event->flags32;
! 	}
! 
! 
  
  	/* Check events */
  	if (!recv_int_page)
***************
*** 307,318 ****
  /*
   * vmbus_set_event - Send an event notification to the parent
   */
! int vmbus_set_event(u32 child_relid)
  {
! 	/* Each u32 represents 32 channels */
! 	sync_set_bit(child_relid & 31,
! 		(unsigned long *)vmbus_connection.send_int_page +
! 		(child_relid >> 5));
  
! 	return hv_signal_event();
  }
--- 405,420 ----
  /*
   * vmbus_set_event - Send an event notification to the parent
   */
! int vmbus_set_event(struct vmbus_channel *channel)
  {
! 	u32 child_relid = channel->offermsg.child_relid;
! 
! 	if (!channel->is_dedicated_interrupt) {
! 		/* Each u32 represents 32 channels */
! 		sync_set_bit(child_relid & 31,
! 			(unsigned long *)vmbus_connection.send_int_page +
! 			(child_relid >> 5));
! 	}
  
! 	return hv_signal_event(channel->sig_event);
  }
